# JFortZoC Mod
# By: Jeckel
#

from CvPythonExtensions import *

import CvAlertManager

###################################################
import CvJDataStorageUtils as data

# data.initTypesDict(pUnit, dictInit=None)
# data.initTypeStatsDict(pUnit, xType)
# data.hasTypesDict(pUnit)
# data.hasTypeStatsDict(pUnit, xType)
# data.hasTypeStat(pUnit, xType, xStat)
# data.setTypeStatsDict(pUnit, xType, dictStats=None)
# data.setTypeStat(pUnit, xType, xStat, xStatValue=None)
# data.delTypesDict(pUnit)
# data.delTypeStatsDict(pUnit, xType)
# data.delTypeStat(pUnit, xType, xStat)
# data.getDataIDStr(pObj=None)
# data.getUnitStatsStrType_StrStatList(pUnit, strDelim="_", bStatsTypeFirst=True)
# data.getTypesDict(pUnit)
# data.getTypeStatsDict(pUnit, xType)
# data.getTypeStat(pUnit, xType, xStat)

# data.initGlobalDict()
# data.hasGlobalDict()
# data.hasGlobalData(xKey)
# data.setGlobalData(xKey, xValue)
# data.getGlobalData(xKey=None)

###################################################
# globals
gc = CyGlobalContext()
localText = CyTranslator()

alert = CvAlertManager.CvAlertManager()

###################################################
class CvJFortZoCUtils:
	def __init__(self):
                self.iLastPlayer = -1
                self.iLastUnitId = -1
                self.bLastReturn = False
                self.tLastPlot = (-1, -1)
                self.dPlotXYs = {}

	################################################################################################

        # Ignore this
        def getRangePlots(self, iX, iY, iRange = 1, bCenter = True):
                iXStart = iX - iRange
                iXStop = iX + iRange + 1
                iYStart = iY - iRange
                iYStop = iY + iRange + 1
                lPlots = []
                for iXLoop in range(iXStart, iXStop):
			for iYLoop in range(iYStart, iYStop):
				iActiveX = iXLoop
				iActiveY = iYLoop
				if (iActiveX < 0):
					iActiveX = CyMap().getGridWidth() + iActiveX
				if (iActiveY < 0):
					iActiveY = CyMap().getGridHeight() + iActiveY
				if (iActiveX == iX) and (iActiveY == iY) and (not bCenter):
                                        continue
				pPlotLoop = CyMap().plot(iActiveX, iActiveY)
				lPlots += [pPlotLoop]
		return lPlots

        def getPlotCultureOwner(self, iX, iY):
                pPlot = CyMap().plot(iX, iY)
                lCultures = []
                for iPlayerLoop in range(gc.getMAX_CIV_PLAYERS() + 1):
                        iCultureLoop = pPlot.getCulture(iPlayerLoop)
                        if (iCultureLoop >= 1):
                                lCultures += [[iCultureLoop, iPlayerLoop]]
                #alert.debug(0, "lCultures", lCultures)
                if (len(lCultures) == 0):
                        return -1
                lCultures.sort(reverse=True)
                lCulture = lCultures[0]
                iPlayer = lCulture[1]
                return iPlayer

	################################################################################################

	def initFortData(self):
                if (not data.hasGlobalData("GlobalFortDict")):
                        data.setGlobalData("GlobalFortDict", {})

        def getAllFortData(self):
                self.initFortData()
                return data.getGlobalData("GlobalFortDict")

        def getFortsList(self):
                dData = self.getAllFortData()
                return dData.keys()

        def hasFortData(self, iX, iY):
                if (not data.hasGlobalData("GlobalFortDict")):
                        return False
                lForts = self.getFortsList()
                tPlot = (iX, iY)
                if (tPlot in lForts):
                        return True
                return False

        def isFort(self, iX, iY):
                return self.hasFortData(iX, iY)

        def getFortData(self, iX, iY):
                dData = self.getAllFortData()
                if (not self.hasFortData(iX, iY)):
                        return None
                tPlot = (iX, iY)
                lData = dData[tPlot]
                lData += [iX, iY]
                return lData

        def addFortData(self, iTurn, iPlayer, iUnitID, iX, iY):
                dData = self.getAllFortData()
                if (not self.hasFortData(iX, iY)):
                        tPlot = (iX, iY)
                        dData[tPlot] = [iTurn, iPlayer, iUnitID]
                        data.setGlobalData("GlobalFortDict", dData)
                        return True
                return False

        def removeFortData(self, iX, iY):
                dData = self.getAllFortData()
                if (not self.hasFortData(iX, iY)):
                        return None
                tPlot = (iX, iY)
                del dData[tPlot]
                data.setGlobalData("GlobalFortDict", dData)

	################################################################################################

	def initZoCTeamData(self):
                if (not data.hasGlobalData("GlobalZoCTeamDict")):
                        data.setGlobalData("GlobalZoCTeamDict", {})

        def getAllZoCTeamData(self):
                self.initZoCTeamData()
                return data.getGlobalData("GlobalZoCTeamDict")

	################################################################################################

	def initZoCData(self):
                if (not data.hasGlobalData("GlobalZoCDict")):
                        data.setGlobalData("GlobalZoCDict", {})

        def getAllZoCData(self):
                self.initZoCData()
                return data.getGlobalData("GlobalZoCDict")

        def getPlayerZoCData(self, iPlayer):
                dData = self.getAllZoCData()
                if (iPlayer not in dData):
                        return []
                return dData[iPlayer]

        def getTeamZoCData(self, iPlayer):
                pPlayer = gc.getPlayer(iPlayer)
                iTeam = pPlayer.getTeam()
                dDataTeam = self.getAllZoCTeamData()
                if (iTeam not in dDataTeam):
                        return []
                return dDataTeam[iTeam]

        def getEnemyZoCData(self, iPlayer):
                pPlayer = gc.getPlayer(iPlayer)
                iTeam = pPlayer.getTeam()
                pTeam = gc.getTeam(iTeam)
                dDataTeam = self.getAllZoCTeamData()
                lPlots = []
                for iTeamLoop in dDataTeam:
                        if (not pTeam.isAtWar(iTeamLoop)):
                                continue
                        lPlotsLoop = dDataTeam[iTeamLoop]
                        lPlots += lPlotsLoop
                return lPlots

        def addFortZoCData(self, iPlayer, iX, iY):
                pPlayer = gc.getPlayer(iPlayer)
                iTeam = pPlayer.getTeam()
                dData = self.getAllZoCData()
                dDataTeam = self.getAllZoCTeamData()
                if (iPlayer not in dData):
                        dData[iPlayer] = []
                if (iTeam not in dDataTeam):
                        dDataTeam[iTeam] = []
                iRange = 1
                iXStart = iX - iRange
                iXStop = iX + iRange + 1
                iYStart = iY - iRange
                iYStop = iY + iRange + 1
                lPlots = []
                for iXLoop in range(iXStart, iXStop):
			for iYLoop in range(iYStart, iYStop):
				iActiveX = iXLoop
				iActiveY = iYLoop
				if (iActiveX < 0):
					iActiveX = CyMap().getGridWidth() + iActiveX
				if (iActiveY < 0):
					iActiveY = CyMap().getGridHeight() + iActiveY
				if (iActiveX == iX) and (iActiveY == iY):
                                        continue
                                tPlot = (iActiveX, iActiveY)
                                dData[iPlayer] += [tPlot]
                                dDataTeam[iTeam] += [tPlot]
                data.setGlobalData("GlobalZoCDict", dData)
                data.setGlobalData("GlobalZoCTeamDict", dDataTeam)

	################################################################################################

        def getFortCommander(self, iX, iY):
                lData = self.getFortData(iX, iY)
                if (lData == None):
                        return None
                iPlayer = lData[1]
                iUnitID = lData[2]
                pPlayer = gc.getPlayer(iPlayer)
                pUnit = pPlayer.getUnit(iUnitID)
                return pUnit

        def getFortOwnerID(self, iX, iY):
                lData = self.getFortData(iX, iY)
                if (lData == None):
                        return -1
                iPlayer = lData[1]
                return iPlayer

        def getFortOwner(self, iX, iY):
                lData = self.getFortData(iX, iY)
                if (lData == None):
                        return None
                iPlayer = lData[1]
                pPlayer = gc.getPlayer(iPlayer)
                return pPlayer

	################################################################################################

	def updatePlotCulture(self, iPlayer, iUnitID, iX, iY):
                #alert.alert(0, "initFortCulture")
                pPlayer = gc.getPlayer(iPlayer)
                pUnit = pPlayer.getUnit(iUnitID)
                iLevel = pUnit.getLevel()
                iRange = 1

                iXStart = iX - iRange
                iXStop = iX + iRange + 1
                iYStart = iY - iRange
                iYStop = iY + iRange + 1

		# Create culture around unit
		for iXLoop in range(iXStart, iXStop):
			for iYLoop in range(iYStart, iYStop):
				iActiveX = iXLoop
				iActiveY = iYLoop
				if (iActiveX < 0):
					iActiveX = CyMap().getGridWidth() + iActiveX
				if (iActiveY < 0):
					iActiveY = CyMap().getGridHeight() + iActiveY
				pPlotLoop = CyMap().plot(iActiveX, iActiveY)
				if (iActiveX == iX) and (iActiveY == iY):
                                        iCulture = iLevel * 2
                                else:
                                        iCulture = iLevel
                                #alert.debug(0, "iPlayer", iPlayer)
                                #alert.debug(0, "iCulture", iCulture)
				pPlotLoop.changeCulture(iPlayer, int(iCulture), True)

	def updateCultureBorders(self, iPlayer, iUnitID, iX, iY):
                #alert.alert(0, "initFortCulture")
                pPlayer = gc.getPlayer(iPlayer)
                pUnit = pPlayer.getUnit(iUnitID)
                iRange = 1
                #alert.debug(0, "iRange", iRange)

                iXStart = iX - iRange
                iXStop = iX + iRange + 1
                iYStart = iY - iRange
                iYStop = iY + iRange + 1

		# Create culture around unit
		for iXLoop in range(iXStart, iXStop):
			for iYLoop in range(iYStart, iYStop):
				iActiveX = iXLoop
				iActiveY = iYLoop
				if (iActiveX < 0):
					iActiveX = CyMap().getGridWidth() + iActiveX
				if (iActiveY < 0):
					iActiveY = CyMap().getGridHeight() + iActiveY
				pPlotLoop = CyMap().plot(iActiveX, iActiveY)
				#alert.debug(0, "iActiveX", iActiveX)
				#alert.debug(0, "iActiveY", iActiveY)
				#alert.debug(0, "pPlotLoop.getOwner()", pPlotLoop.getOwner())
				#if (pPlot.getOwner() == -1) or ((iActiveX == iX) and (iActiveY == iY)):
					#pPlotLoop.setOwner(iPlayer)
				iOwnerLoop = self.getPlotCultureOwner(iActiveX, iActiveY)
				if (iOwnerLoop == -1):
                                        pPlotLoop.setOwner(iPlayer)
                                else:
                                        pOwnerLoop = gc.getPlayer(iOwnerLoop)
                                        if (pOwnerLoop.isAlive()):
                                                pPlotLoop.setOwner(iOwnerLoop)

	################################################################################################
        # Most of this needs to be rewritten

        def isFortZoC(self, iX, iY):
                lForts = self.getFortsList()
                iRange = 1
                iXStart = iX - iRange
                iXStop = iX + iRange + 1
                iYStart = iY - iRange
                iYStop = iY + iRange + 1
		for iXLoop in range(iXStart, iXStop):
			for iYLoop in range(iYStart, iYStop):
				iActiveX = iXLoop
				iActiveY = iYLoop
				if (iActiveX < 0):
					iActiveX = CyMap().getGridWidth() + iActiveX
				if (iActiveY < 0):
					iActiveY = CyMap().getGridHeight() + iActiveY
				pPlotLoop = CyMap().plot(iActiveX, iActiveY)
				if (pPlotLoop.getOwner() == -1):
                                        continue
				tPlot = (iActiveX, iActiveY)
				if (tPlot in lForts):
                                        return True
                return False

        def isPlayerFortZoC(self, iPlayer, iX, iY):
                lPlots = self.getPlayerZoCData(iPlayer)
                tPlot = (iX, iY)
                if (tPlot in lPlots):
                        return True
                return False

        def isTeamFortZoC(self, iPlayer, iX, iY):
                lPlots = self.getTeamZoCData(iPlayer)
                tPlot = (iX, iY)
                if (tPlot in lPlots):
                        return True
                return False

        def isEnemyFortZoC(self, iPlayer, iX, iY):
                lPlots = self.getEnemyZoCData(iPlayer)
                tPlot = (iX, iY)
                if (tPlot in lPlots):
                        return True
                return False

	################################################################################################

















